( 3iBeats_cookbook.fs - AE - 2021-05-24---Mon---08:09 )

\ include 3iForth, 3iShift.fs
\ help-shiftin  (init twice)
\ .b
\ >b8

\ 2021-05-24---Mon---08:32
\ IDEA: create a beats entry module --- OLED screen, simple menu -- bar 1 through bar 8, clear, enter 1 (strike) or 0 (rest) buttons
\   scroll through the 4 notes in the bar in 1 e and a notation...
\   enter and then loop
\ slow or fast metronome with a potentiometer
\ complements the hardware beats selector with DIP switch that is likely to be quite challenging to set/unset
\ Can an ATTINY monitor 16-key keypad effectively?

\ 8x 16th notes = 4x quarter notes = 1 bar

\ basics
: beatA1 $F 1 ;          \ semiquavers 16th notes
: beatA2 $A 1 ;          \ quavers      8th notes
: beatA3 $8 1 ;          \ crotchets    1/4 notes
: beatA4 $8 $0 2 ;       \ minims       1/2 notes
: beatA5 $8 $0 $0 $0 4 ; \ semibreve    whole note  (bar)
\ short phrase is 2 bars
\ long  phrase is 4 bars

: beatB $F $E 2 ;  \ 7/8 on 1
: beatB $F $D 2 ;  \ 7/8 on 2?
: beatB $F $B 2 ;  \ 7/8 on 3?
: beatB $F $7 2 ;  \ 7/8 on 4?
: beatB $E $F 2 ;  \ 7/8 on 5?
: beatB $D $F 2 ;  \ 7/8 on 6?

: beatC $F $A 2 ;

: beatD $F $6 2 ;

: beatE $F $5 2 ; \ rapper beat
: beatE $E $C 2 ; 

: beatF $F $4 2 ;
: beatF $F $2 2 ;
: beatF $E $D 2 ;

: beatG $E $E 2 ; \ regular 3's
: beatG $E $A 2 ; \ irregular 3's
: beatG $E $8 2 ; \ syncopated 3's
: beatG $E $0 2 ; \ isolated 3's
: beatG $E $1 2 ; \ isolated 4's

: beatH $D $A 2 ; \ samba?


\ INDIAN beats

: regular1 $8      1 ;
: regular2 $A      1 ;
: tan-tada $8 $B   2 ;
: da-dum   $8 $4 $8 $8   4 ;  \ like garba?
: beat1    $9 $5 $2 $4   4 ;
: beat2    $F $0   2 ;
: 12talala $A $B   2 ;
: rasra1 ( -- ) 125 beatdur! $9 $C     2 ;  \ 2 beat rests give this a slightly off-beat flavor
: rasra2 ( -- ) 125 beatdur! $B $8     2 ;
: rasra3 ( -- ) 180 beatdur! $B $A $E  3 ; \ 1 beat rests provide right emphasis, need 6 notes to cover beat (6/8 time)
\ ginan garbi: https://www.jollygul.com/ginans-garbi/
\ 9: pir nachine kanthe ginanre ma   Scale: Indian Todi raga  Lyrics: http://www.ismaili.net/heritage/node/24298
\ 1: evi garbi sampurana
\ 7: gur vadea dasmi rat 


\ JASMINE
: jasmine-beat1  $B 6 4   3 ;           \ poem - tempo 220
: jasmine-beat2  $B 6 4 $F $E $C   6 ; 

\ ASSAD
: uptown-beat    8 8 $B 0   $A $B 0 0   8 8 $B 0   $A $F 8 0     16 ;   \ 1000 1000 1011 0000   1010 1011  ...
: uptown-hey     8 8 $B 0   $A $B 2 8   8 8 $B 0   $A $F 11 8     16   
    tones-uptown load-tones ;   \ 1000 1000 1011 0000   1010 1011  ...      use: uptown-hey nbeats

\ Youtube Drummer
: groove139  \ 4 bars of semiquavers, 2-bit or 3-bit drumming
    $F $7 $D $9  
    $F $7 $C $0  
    $F $7 $C $C 
    $F $0 $F $C   
    16 
    snare hi-hat load-tones  \ play directly with [play-tones] instead of play-next and next (rest) in nibble loop of beats.fs
;

\ ===================================================
\ V2 - 2021-06-01---Tue---02:04  added: beat sequence with tones -- for two-tone drum for e.g. garbi -- bass and snare or clap & snap
