\ Clean Playlist Book - for the Digital Piano -- include 3iPiano.fs  

\ Design: this playlist plays notes provided in 1-8 format


\ CODE REVIEW: Get to a musical data structure -- 3 arrays
\ play directly from stack, left to right
: play ( n -- ) init-scaleroot dup 0 do dup i - roll .. loop drop ( clear32 ) ;  \ clear32 from 3iShift.fs
\ : watch ( n -- ) dup 0 do dup i - roll #__ 500 ms light| 100 ms loop drop light| ; \ 
\ learn each note and use PC to prompt next note --- LATER: read key to check it's the right one being pressed
: learn ( n -- ) init-scaleroot dup 0 do dup i - roll .. key drop loop drop clear32 ;

\ TO DO: add ESC to play rest.  Add back key to go back.  Add play a phrase key.
\ TO DO: how to flash?


\ Classical Pieces
\ https://www.youtube.com/watch?v=VfPGNafN8K8
\ https://www.google.com/search?client=firefox-b-d&q=simple+classical+tunes

: new-harp
   3 2 1 2 3 5 5 4 4
   4 3 2 3 4 6 6 5 5
   3 2 1 2 3 5 5 4 4
   4 3 2 4 3 2 3 1 1
   8 7 6 5 8 7 6 5 8 7 6 5 4 3 2
   7 6 5 7 6 5 7 6 5 4 3 2 1
64
; 

\ Beethoven's Ode to Joy
: ode
    3 3 4 5 5 4 3 2 1 1 2 3 3 2 2 
    3 3 4 5 5 4 3 2 1 1 2 3 2 1 1 
    2 2 3 1 2 3 4 3 1 2 3 4 3 2 1 2 << 5 >>
    3 3 4 5 5 4 3 2 1 1 2 3 2 1 1
64
;

\ Bach: Jesu, Joy of Man's Desiring  (Jesu, bleibet meine Freude) BWV 147/10, Last chorus of the cantata Herz und Mund und Tat und Leben BWV 147, 14:13
\ https://www.youtube.com/watch?v=6ZKGD2IIhjk
\ Cello, Guitar Duo: https://www.youtube.com/watch?v=KialZHRdD7A
\ Piano (liquid legato): https://www.youtube.com/watch?v=uKq5IcBFyeQ
\ Organ: https://www.youtube.com/watch?v=2uXn6nDN7ck    
\ Jesus, joy of man's desiring 
\ Holy wisdom, love most bright 
\ Drawn by Thee, our souls aspiring Soar to uncreated light 
\ Word of God, our flesh that fashioned 
\ With the fire of life impassioned 
\ Striving still to Truth unknown Soaring, dying 'round Thy throne
: jesu-g
  5 6 7 >> 2 1 1 3 2 2 5 4# 5 2 << 7 5 6 7 8 6 5 2 5 4# 5
  26
;

: jesu-c
  1 2 3 5 4 4 6 5 5 8 7 8 5 3 1 2 3 4 2 << 7  5 6 7 >>
  1 2 3 5 4 4 6 5 5 8 7 8 5 3 1 2 3 4 5 6 5 3 2 << 5 >> 1 << 7 >> 1
  56
;

\ Fur Elise
\ https://www.sheetmusicdirect.com/en-US/se/ID_No/433968/Product.aspx
: elise
  >> 
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 5# 7 >> 1
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 >> 1 << 7 6
  
  7 >> 1 2 3 << 3 >> 4 3 2 << 3 >> 3 2 1  << 3 >> 2 1 << 7 >> 3  

  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 5# 7 >> 1
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 >> 1 << 7 6
129 
;


\ Pachelbel: Canon in D, 00:00 - 4:45
\ https://www.sheetmusicdirect.com/en-US/se/ID_No/103307/Product.aspx


\ Beethoven: Moonlight Sonata


\ FAMOUS POP TUNES

: memory
    8 8 
    7 8 >> 2 << 8 6 8 8
    7 8 >> 2 << 8 5 6 6
    4 5 6 5 4 3
    3 5 5 2 
    3 4 5 6 7 8 7 6 5
    3 1 5
    << 7 7 >> 1 1
48
;

: stairway
  4 5 6% 5 4 5 
  4 5 6% 7% 6% 5
  6% 7% 8 7% 6% 5 4 3% 3% 4 4
  4  4 >> 1# << 8
29
;  

\ abba I have a dream
: dream
todi 1
 6 5 7
1 4 3 4
1 6 5 7 
5 4 3 4
6 7 8 >> 2 << 1 5 
5 6 7 8 6
6 7 8 >> 2 << 8 5
5 6 7 8 6
( high ) 1 2 3 4 3 ( low ) 7
7 8 ( high )  2 3 2 1 ( oow ) 7 6 8 8 
( high ) 1 2 3 4 3 ( low ) 7 
7 8 2 3 2 1 7 6 8 8 
1 6 5 7
1 4 3 4
; 

\ YU -- I see Fire by Ed Sheeran


\ TRADITIONAL

: daffodils
    4 4 3 2 3 
    5 5 4 3 4 5 
    6 6 5 4 6
    7% 7% 6 5 6 7%
    8 8 7% 6 4 7% 6 5 4 3 
    1 2 3 4 4 3 2 2 2 5 5 4 3
    1 2 3 4 4 3 2 2 2 5 5 4 3
58
;

: scarborough
  1 1 5 5 5 2 3% 2 1 
  5 7% 8 7% 5 6 4 5
  8 8 8 7% 5 5 4 3% 2 1
  1 5 4 3% 2 1 << 7% >> 1 
37
;  

\ ETHNOMUSIC

: sea
  1 1 5  5 6 4 5
  1 1 5  5  6 4 8 7% 6 5
  >> 1 2 3% 4 3% 2
  1 1 2 3% 4 3% 5
  <<
  1 1 5  5 6 4 5
  1 1 5  5  6 4 8 7% 6 5
48
;


\  PERSONAL COMPOSITIONS

: dreaming  \  by Meera Shah Ebrahim 2021-05-16---Sun---21:34
>> 1 2 3 3  1 2 3 3  1 2 3 2 1 << 7 
7 8 >> 2 2  << 7 8 >> 2 2  7 8 >> 2 3 2 1
3 2 1 1 << 3 2 1 1  3 2 1 2 1 << 7 
7 >> 1 2 2  << 5 7 >> 2 2 << 5 7 >> 2 3 2 1
69
;

: tog   \ Together, by Jasmine Sheherazade Ebrahim
8  7  8 7 8 7 8 6 6
7  6  7 6 7 6 7 5 5
6  5  6 5 6 5 6 4 4
5  4  3 8 8 3 4
34 
;

: snake  \ Snake Charmer, by Assad Ebrahim
 1  3  4 5 
 5  6% 5 6% 4  5
 1  3 4 5 
 3  4 3 4 3 1
   
 1  3 4  5 
 5  6% 7% 6% 5 4 5
 4  3 4 3 4 3 1
 
 7% 6%  7% 6%  7% 6%  5 4  5 
 1 3 4 5
 3 4 3 4 3 4 3 1 
28
;


: planets  \  Planets, by Assad Ebrahim - 2020-07-10---Fri---03:32
 3 5 6 
 3 5 6 8 7 6 5 6 
 11
;


: jimmy-boy  \ Jimmy Boy, by Assad Ebrahim  2020-07-15---Wed---03:38
 cmaj
 1 .. 2 .. 3 .. 5 .. R1 5 .. 6 .. 5 .. 4 .. 5 .. R2      \ oh jimmy-boy!  where are you running?
 1 .. 2 .. 3 .. 5 .. R1 5 .. 4 .. 3 .. 3 .. 4 .. R2      \ oh jimmy-boy!  what have you done?
 1 .. 2 .. 3 .. 5 .. R1 5 .. 6 .. 5 .. 4 .. 5 .. R2      \ oh jimmy-boy!  where will you run to?
 1 .. 2 .. 3 .. 4 .. R1 4 .. 5 .. 4 .. 3 .. 2 .. 3 .. R2 \ oh jimmy-boy!  I fear your time has come.
 cstd
;

\ Assad Ebrahim - 2021-05-12---Wed---05:18
: falling
cr ." Falling Down, by Assad Ebrahim"
\ this uses the pentatonic scale  5_ 7_ 1 2 4 5    g b c d f 
  2 5 4 2 1 2        \ the walls came tumbling down
  << 8 7 8 7 8 7 5 >>  \ falling, falling, falling down 
\ can also shift to start on g
  5 8 7 5 4 5 
  4 3 4 3 4 3 1
;


\ CHILDRENS

: doh
    1 2 3 1 3 1 3
    2 3 4 4 3 2 4
    3 4 5 3 5 3 5
    4 5 6 6 5 4 6
    5 1 2 3 4 5 6
    6 2 3 4 5 6 7
    7 3 4 5 6 7 8
    8 7 6 4 7 5 8
    1 2 3 4 5 6 7 8
64
;

: twinkle
    1 1 5 5 6 6 5 
    4 4 3 3 2 2 1
    5 5 4 4 3 3 2 
    5 5 4 4 3 3 2
    1 1 5 5 6 6 5
    4 4 3 3 2 2 1
    42
;    \ then play, watch or learn


\ mary had a little lamb
: mary
    3 2 1 2 3 3 3
    2 2 2
    3 5 5
    3 2 1 2 3 3 3  1 2 2 3 2 1
    26 ;

: alouette 
    1 2 3 3 
    2 1 2 3 1   
    1 2 3 3 
    2 1 2 3 1
    1 2 3 4 5 5 5 
    5 6 5 4 3 2 1
    5 5 5 
    1 1 1
    5 5 5
    1 1 1
    5 4 3 2  \ repeat
48
;


: row-row
    1 1 1 2 3 
    3 2 3 4 5
    8 8 5 5 3 3 1 1
    5 4 3 2 1
23
; 

: london-bridge
    5 6 5 4 3 4 5 
    2 3 4   3 4 5
    5 6 5 4 3 4 5 
    2 5 3 1
24
;

\ jack and jill

: weasel  \ pop goes the weasel?
    1 1 2 2 3 5 3 1
       1 1 2 2 3 1 
    1 1 2 2 3 5 3 1
    6 2 4 3 1
27
;
    
\ little bo peep

\ baa baa black sheep
: baa
  1 1 5 5 6 7 8 6 5
  4 4 3 3 2 2 1 
  5 5 5 4 4 4 3 3 3 2
  1 5 5 5 4 5 6 4 3 2 2 1
38
;

: lavender \ lavender blue
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
  
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1

  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
  
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
96
;

: frere \ frere jacques
     1 2 3 1   1 2 3 1  
     3 4 5     3 4 5
     5 6 5 4 3 1   5 6 5 4 3 1 
     1    1     1     1
30
;

: cockles \   cockles and mussels
    1 1 1 1 3    1 1 2 2 2 2 4
    3 3 3 5 4 3   3 2 1 2 
    1 1 1 1 3    1 2 2 2 2 4
    3 1 5 3   1  5 3  
    1 2 3 2 1
45
;

: robin-hood
    2 2 2 3 4 5 5 5 
    6 7 8 5 5 6 5 4 3 1 
    5 1 1 1 3 4 5 5 5 
    6 7 8  5 5 6 5 4 3 1
    5 6 6 6 5 4 3 4 5 6 5 
    5 6 8 5 5 6 5 4 3 1
58
;

\ bonnie lies over the ocean
: bonnie
    1 6 5 4 5 4 2 1 << 6 >>
    1 6 5 4 4 3 4 5 
    1 6 5 4 5 4 2 1 << 6 >>
    1 1 5 4 3 2 3 4 
    
    1 4  3 1 4  3 3 3 3 2 3 4  5 6 
    1 4  3 1 4  3 3 3 3 2 3 4  5 6 
66
;

\ old macdonald


: uk-anthem  \ god save the queen
    4 4 5 3 4 5
    6 6 7% 6 5 4 
    5 4 3 4 
    4 5 6 7%
    8 8 8 8 7% 6 
    7% 7% 7% 7% 6 5
    6 7% 6 5 4 6 7% 8 
    >> 2 << 7% 6 5 4
47
; 


\ AMERICAN FOLK SONGS

\ swing low sweet chariot
: chariot
    6 4 6 4 4 2 1 
    4 4 4 5 6 6 8 8
    >> 2 << 8 6 8 4 4 2 1 
    4 4 4 5 6 6 5 4
33
;

\ yankee doodle

\ michael finnegan
: finnegan
    1 4 4 4 4 6 8 8 6 5 4
    5 5 5 5 4 5 3 2 1
    4 4 4 4 6 8 8 6 5 4
    5 5 1 1 4 4 4  4 4 4 4
41
;

\ o give me a home (home on the range)
: home
  1 1 4 5 6
  4 3 2 7% 7% 7%
  6 7% 8 4 4 4 3 4 5 
  1 1 1 4 5 6
  4 3 2 7% 7% 7%
  7% 7% 6 5 4 3 4 5 4
  
  8 7% 6 5 6
  1 1 4 4 4 4 3 4 5
  1 1 1 4 5 6
  4 3 2 7% 7% 7%
  7% 7% 6 5 4 3 4 5 4
76
;

\ america the beautiful

\ star spangled banner
: USA
    8 6 4 6 8 >> 4
    6 5 4 << 
    6 7% 8
    8 8 >> 6 5 4 3 
    2 3 4 4 1 << 6 4 
    8 6 4 6 8 >> 4 
    6 5 4 << 6 7% 8
    8 8 >> 6 5 4 3 
    2 3 4 4 1 << 6 4
    >> 6 6 6 7% 8 8 
    7% 6 5 6 7% 7%
    7% 6 5 4 3
    2 3 4 << 6 7% 8
    8 >> 4 4 4 3 2 2 2   5 6 7% 6 5 4 4 3 
    1 1 4 5 6 7% 8 
    4 5 6 7% 5 4
113
;     
    
\ drunken sailor

\ o susanna
: susanna
    4# 5# 6# c#' d#' c#' 6# 4# 5# 6# 6# 5# 4# 5#
    4# 5# 6# c#' c#' d#' c#' 6# 4# 5# 6# 6# 5# 5# 4#
    4# 5# 6# c#' d#' c#' 6# 4# 5# 6# 6# 5# 4# 5#
    4# 5# 6# c#' c#' d#' c#' 6# 4# 5# 6# 6# 5# 5# 4#
;    

\ she'll be coming round the mountain
: round-mountain
    1# 2# 4# 4# 4# 2# 1# 1# 2# 4#
    4# 5# 6# 6# 6# 6#   6# 5# 4# 5#
        6# 6# 6# 6# 5# 4# 
    2# 2# 2# 2# 6# 6#
    6# 6# 5# 5# 6# 5# 4#
39
;

\ naussau

\ oh bury me not
: cowboy  \ cowboys lament, folk song, johnny cash : https://en.wikipedia.org/wiki/Bury_Me_Not_on_the_Lone_Prairie
\ alt: Chinese yu scale
  1 3% 3% 5 7%
  8 7% 5 3% 5
  3% 3% 5 7% 6%
15
;  

: betsy  \ sweet betsy from pike
  1 1 3 5 5 4 2 2 1 << 7 >> 1
  1 1 3 5 8 8 8 8 5 5 5
  5 8 8 8 7 5 3 4 5 6 5
  1 2 3 3 3 5 4 2 2 1 << 7 >> 1
49
; 

: old-smokey
  1 1 3 5 8 6
  6 4 5 6 5
  1 1 3 5 5 2 
  3 4 3 2 1

  1 1 3 5 8 6
  6 4 5 6 5
  1 1 3 5 5 2 
  3 4 3 2 1
44
;

: my-room  \ beach boys
  2 2 3 2 4# 4# 5 4# 6 6 7 5 6
  6 4# 3  5 4# 2
19
;
   

: green-day
  5 7 8 7   5 7 8 7   5 7 8 7  5 5
14
;

: star-wars
  1 5 4 3 2 8 5   4 3 2 8 5   4 3 4 2
1 1 5 4 3 2 8 5   4 3 2 8 5   4 3 4 2
33 
;

: top-gun
  1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 3 2
1 1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 5
  1 2 3 4 5 6 7 >>
  1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 3 2
1 1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 5
84
;

: bday
    1 1 2 1 4 3
    1 1 2 1 5 4 
    1 1 8 6 4 3 2
    7% 7% 6 3 5 4
;

\ axle-f

\ chopstix

: silent-night
    4 5 4 2 
    4 5 4 2
    7% 7% 5 6 6 4
    5 5 7% 6 5 4 5 4 2
    5 5 7% 6 5 4 5 4 2
    >> 1 1 3% 1 << 6 7% >> 2
    << 7% 4 2 4 3% 1 << 7%
51
;

\ ======================================

: help-playlist
cr 
cr ." HELP-PLAYLIST"
cr ." -------------"
cr ." by Assad Ebrahim - http://www.mathscitech.org/articles"
cr 
cr ." includes: 3iForth.fs [3iLight.fs] 3iPort-4x4.fs 3iSound-4x4.fs 3iPiano.fs 3iPlaylist.fs"
cr ." init: 1 open-com   INIT-PIANO"
cr ." playlist: <songname> play | watch | learn"
cr ." help-songs"
cr 
;



\ V3 - 2021-05-16---Sun---17:14 - perfected the multi-octave notation